===============================================================================
=
Listing 1
Caption:    A Point abstract data type with operator overloading
File:       point.cpp
===============================================================================
=
#include <iostream.h>
class Point
{
    int _x, _y;
public:
            Point(int x=0,      // constructor
                  int y=0)      { _x = x; _y = y; }
    int     x()                 { return _x; }
    int     y()                 { return _y; }
    void    x(int x)            { _x = x; }
    void    y(int y)            { _y = y; }
    Point   operator+(Point p)  { return Point(_x + p.x(),
                                               _y + p.y()); }
    Point   operator*(int i)    { return Point(_x * i,
                                               _y * i); }
    friend
    ostream &operator<<(
                ostream &os,
                Point p)        { return os << p.x()
                                            << " @ "
                                            << p.y(); }
};
 
main()
{
    cout << "Point class demo\n";
    Point p1(200, 100);         // construct p1
    Point p2( 20,  10);         // construct p2
    Point p3 = p1 + p2;         // construct p3 and
                                // initialize to (220, 110);
    cout << p3 << "\n";         // print p3 using << operator
 
    p3 = p1 * 2;                // set p3 to (400, 200);
    cout << p3 << "\n";         // print p3 using << operator
    return 0;
}
