' RGNEDIT.FRM
' Utility to help you define regions in a bitmap
' ==============================================

VERSION 2.00
Begin Form frmMain 
   Caption         =   "Region Editor"
   Height          =   3300
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   2610
   ScaleWidth      =   5475
   Top             =   1140
   Width           =   5595
   Begin ListBox lstBuffer 
      Height          =   1395
      Left            =   2880
      TabIndex        =   4
      Top             =   240
      Visible         =   0   'False
      Width           =   2415
   End
   Begin PictureBox picView 
      BackColor       =   &H00FFFFFF&
      Height          =   1215
      Left            =   240
      ScaleHeight     =   79
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   127
      TabIndex        =   2
      Top             =   120
      Width           =   1935
      Begin PictureBox picWork 
         AutoRedraw      =   -1  'True
         AutoSize        =   -1  'True
         Height          =   4920
         Left            =   120
         ScaleHeight     =   4890
         ScaleWidth      =   9405
         TabIndex        =   3
         Top             =   120
         Width           =   9435
      End
   End
   Begin VScrollBar VScroll 
      Height          =   1335
      Left            =   2280
      Max             =   1
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
   Begin HScrollBar HScroll 
      Height          =   255
      Left            =   360
      Max             =   1
      TabIndex        =   0
      Top             =   1440
      Width           =   1335
   End
   Begin Menu mnuFileMenu 
      Caption         =   "&File"
      Begin Menu mnuFileNew 
         Caption         =   "&New"
      End
      Begin Menu mnuFileSave 
         Caption         =   "&Save"
      End
      Begin Menu Sep1 
         Caption         =   "-"
      End
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnuScaleMode 
      Caption         =   "Scale&Mode"
      Begin Menu mnuScale 
         Caption         =   "1 - Twip"
         Checked         =   -1  'True
         Index           =   1
      End
      Begin Menu mnuScale 
         Caption         =   "2 - Point"
         Index           =   2
      End
      Begin Menu mnuScale 
         Caption         =   "3 - Pixels"
         Index           =   3
      End
      Begin Menu mnuScale 
         Caption         =   "4 - Character"
         Index           =   4
      End
      Begin Menu mnuScale 
         Caption         =   "5 - Inch"
         Index           =   5
      End
      Begin Menu mnuScale 
         Caption         =   "6 - Millimeter"
         Index           =   6
      End
      Begin Menu mnuScale 
         Caption         =   "7 - Centimeter"
         Index           =   7
      End
   End
   Begin Menu mnuSorting 
      Caption         =   "&Sorting"
      Begin Menu mnuSort 
         Caption         =   "Max &X"
         Checked         =   -1  'True
         Index           =   0
      End
      Begin Menu mnuSort 
         Caption         =   "Max &Y"
         Index           =   1
      End
   End
End
DefInt A-Z

Dim BMPName$, RGNName$
Dim SWidth
Dim CR$
Dim XFactor!
Dim YFactor!
Dim SortBy

Sub Form_Load ()
    picWork.Move 0, 0, 0, 0
    SWidth = VScroll.Width
    CR$ = Chr$(13) + Chr$(10)
    mnuScale_Click (1)
    mnuSort_Click (0)
End Sub

Sub Form_Resize ()
    VScroll.Move ScaleWidth - SWidth, 0, SWidth, ScaleHeight - SWidth
    HScroll.Move 0, ScaleHeight - SWidth, ScaleWidth - SWidth, SWidth
    picView.Move 0, 0, ScaleWidth - SWidth, ScaleHeight - SWidth
    If picWork.Width > picView.ScaleWidth Then
        HScroll.Max = picWork.Width - picView.ScaleWidth
    Else
        HScroll.Max = 1
    End If
    If picWork.Height > picView.ScaleHeight Then
        VScroll.Max = picWork.Height - picView.ScaleHeight
    Else
        VScroll.Max = 1
    End If
End Sub

Sub HScroll_Change ()
    picWork.Left = HScroll.Value * -1
End Sub

Sub HScroll_Scroll ()
    picWork.Left = HScroll.Value * -1
End Sub

Sub mnuFileExit_Click ()
    Unload Me
End Sub

Sub mnuFileNew_Click ()
    BMPName$ = InputBox$("Please include path", "Bitmap to Load")
    If BMPName$ <> "" Then
        RGNName$ = BMPName$
        Mid$(RGNName$, Len(RGNName$) - 2) = "RGN"
        picWork.Picture = LoadPicture(BMPName$)
        Form_Resize
    End If
End Sub

Sub mnuFileSave_Click ()
    Open RGNName$ For Output As #1
        For Row = 0 To lstBuffer.ListCount - 1
            Text$ = lstBuffer.List(Row)
            Print #1, Text$
        Next
    Close
End Sub

Sub mnuScale_Click (Index As Integer)
    mnuScale(picWork.ScaleMode).Checked = False
    mnuScale(Index).Checked = True
    picWork.ScaleMode = Index
    XTwips = Screen.TwipsPerPixelX
    YTwips = Screen.TwipsPerPixelY
    Select Case Index
        Case 1                      'Twips
            XFactor! = XTwips
            YFactor! = YTwips
        Case 2                      'Points
            XFactor! = XTwips / 20
            YFactor! = YTwips / 20
        Case 3                      'Pixels
            XFactor! = 1
            YFactor! = 1
        Case 4                      'Characters
            XFactor! = XTwips / 120
            YFactor! = YTwips / 240
        Case 5                      'Inches
            XFactor! = XTwips / 1440
            YFactor! = YTwips / 1440
        Case 6                      'Millimeters
            XFactor! = XTwips / 57
            YFactor! = YTwips / 57
        Case 7                      'Centimeters
            XFactor! = XTwips / 567
            YFactor! = YTwips / 567
    End Select
End Sub

Sub mnuSort_Click (Index As Integer)
    mnuSort(SortBy).Checked = False
    SortBy = Index
    mnuSort(SortBy).Checked = True
End Sub

Sub picWork_MouseUp (Button As Integer, Shift As Integer, X As Single, Y As Single)
    Clr& = picWork.Point(X, Y)
    pColor$ = "&H" + Hex$(Clr&)
    MaxX! = X
    While picWork.Point(MaxX! + XFactor!, Y) = Clr&
        MaxX! = MaxX! + XFactor!
    Wend
    MaxY! = Y
    While picWork.Point(X, MaxY! + YFactor!) = Clr&
        MaxY! = MaxY! + YFactor!
    Wend
    Text1$ = "X: " & X & CR$
    Text2$ = "Y: " & Y & CR$
    Text3$ = "XMax: " & MaxX! & CR$
    Text4$ = "YMax: " & MaxY! & CR$
    Text5$ = "Color: " + pColor$ + CR$
    Prompt$ = Text1$ + Text2$ + Text3$ + Text4$ + Text5$
    Key$ = InputBox$(Prompt$, "Enter Key Value")
    If Key$ <> "" Then
        Text$ = Key$ + "," & X & "," & Y & "," & MaxX! & "," & MaxY! & "," & Clr&
        If SortBy = 0 Then
            TempKey& = Int(MaxX! * 100)
        Else
            TempKey& = Int(MaxY! * 100)
        End If
        i = 0
        If lstBuffer.ListCount > 0 Then
            While lstBuffer.ItemData(i) < TempKey&
                i = i + 1
            Wend
        End If
        lstBuffer.AddItem Text$, i
        lstBuffer.ItemData(i) = TempKey&
    End If
End Sub

Sub VScroll_Change ()
    picWork.Top = VScroll.Value * -1
End Sub

Sub VScroll_Scroll ()
    picWork.Top = VScroll.Value * -1
End Sub
